using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;

namespace DemoSQLParams
{
    class Program
    {
        static OleDbConnection conn = null;
        static void InitConn()
        {
            string dbstr = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Fruits.mdb";
            conn = new OleDbConnection(dbstr);
        }

        // uses string concatenation
        static void AddPurchase1(string trans, int qty, string product, double price)
        {
            conn.Open();
            // Console.WriteLine(sqlString);
            OleDbCommand cmd = new OleDbCommand();
            cmd.Connection = conn;
            cmd.CommandText = "INSERT into PURCHASE(transactioncode,quantity,product,unitprice) " +
                    "VALUES('" + trans + "'," + qty + ",'" +
                    product + "'," + price + ")";
            int res = cmd.ExecuteNonQuery();
            if (res == 1)
                Console.WriteLine("Record added");
            conn.Close();
        }

        // uses string.Format method
        static void AddPurchase2(string trans, int qty, string product, double price)
        {
            conn.Open();
            // Console.WriteLine(sqlString);
            OleDbCommand cmd = new OleDbCommand();
            cmd.Connection = conn;
            cmd.CommandText = 
               "INSERT into PURCHASE(transactioncode,quantity,product,unitprice) " +
                    "VALUES(?,?,?,?)";
            cmd.Parameters.Add("@NameOfField", OleDbType.VarChar).Value = trans;
            cmd.Parameters.Add("@NameOfField", OleDbType.Integer).Value = qty;
            cmd.Parameters.Add("@NameOfField", OleDbType.VarChar).Value = product;
            cmd.Parameters.Add("@NameOfField", OleDbType.Double).Value = price;
            int res = cmd.ExecuteNonQuery();
            if (res == 1)
                Console.WriteLine("Record added");
            conn.Close();
        }

        // uses parameterized SQL statement
        static void AddPurchase3(string trans, int qty, string product, double price)
        {
            conn.Open();
            // Console.WriteLine(sqlString);
            OleDbCommand cmd = new OleDbCommand();
            cmd.Connection = conn;
            cmd.CommandText =
               string.Format("INSERT into PURCHASE(transactioncode,quantity,product,unitprice) " +
                    "VALUES('{0}',{1},'{2}',{3})", trans, qty, product, price);
            int res = cmd.ExecuteNonQuery();
            if (res == 1)
                Console.WriteLine("Record added");
            conn.Close();
        }

        static void ClearPurchaseTable()
        {
            conn.Open();
            // Console.WriteLine(sqlString);
            OleDbCommand cmd = new OleDbCommand();
            cmd.Connection = conn;
            cmd.CommandText = "DELETE FROM PURCHASE";
            int res = cmd.ExecuteNonQuery();
            conn.Close();
        }

        static void Main(string[] args)
        {
            InitConn();
            ClearPurchaseTable();
            AddPurchase1("0001", 5, "apples", 3.50);
            AddPurchase2("0002", 2, "mangoes", 9.50);
            AddPurchase2("0003", 2, "bananas", 1.50);
            AddPurchase3("0004", 3, "pomelos", 3.25);
            AddPurchase3("0005", 3, "papayas", 8.25);
        }
    }
}
